spot 2.3.4

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Modules Pages
Public Member Functions | Protected Attributes | List of all members
spot::fair_kripke_succ_iterator Class Referenceabstract
TωA (Transition-based ω-Automata) » Kripke Structures

Iterator code for a Fair Kripke structure. More...

`#include <spot/kripke/fairkripke.hh>`

Inheritance diagram for spot::fair_kripke_succ_iterator:
Collaboration diagram for spot::fair_kripke_succ_iterator:

## Public Member Functions
| fair_kripke_succ_iterator (const bdd &cond, acc_cond::mark_t acc_cond)
| Constructor. More...
virtual bdd | cond () const override
| Get the condition on the edge leading to this successor. More...
virtual acc_cond::mark_t | acc () const override
| Get the acceptance mark of the edge leading to this successor. More...
Iteration
virtual bool | first ()=0
| Position the iterator on the first successor (if any). More...
virtual bool | next ()=0
| Jump to the next successor (if any). More...
virtual bool | done () const =0
| Check whether the iteration is finished. More...
Inspection
virtual const state * | dst () const =0
| Get the destination state of the current edge. More...

## Protected Attributes
bdd | cond_
acc_cond::mark_t | acc_cond_

## Detailed Description

Iterator code for a Fair Kripke structure.

This iterator can be used to simplify the writing of an iterator on a Fair Kripke structure (or lookalike).

If you inherit from this iterator, you should only redefine

- fair_kripke_succ_iterator::first()
- fair_kripke_succ_iterator::next()
- fair_kripke_succ_iterator::done()
- fair_kripke_succ_iterator::dst()

This class implements fair_kripke_succ_iterator::cond(), and fair_kripke_succ_iterator::acc().

## Constructor & Destructor Documentation

spot::fair_kripke_succ_iterator::fair_kripke_succ_iterator | ( | const bdd & | cond,
|  | acc_cond::mark_t | acc_cond
| ) |  |

Constructor.

The cond and acc_cond arguments will be those returned by fair_kripke_succ_iterator::cond(), and fair_kripke_succ_iterator::acc().

## Member Function Documentation

virtual acc_cond::mark_t spot::fair_kripke_succ_iterator::acc | ( |  | ) | const
| override virtual

Get the acceptance mark of the edge leading to this successor.

Implements spot::twa_succ_iterator.

virtual bdd spot::fair_kripke_succ_iterator::cond | ( |  | ) | const
| override virtual

Get the condition on the edge leading to this successor.

This is a boolean function of atomic propositions.

Implements spot::twa_succ_iterator.

virtual bool spot::twa_succ_iterator::done | ( |  | ) | const
| pure virtual inherited

Check whether the iteration is finished.

This function should be called after any call to `first()` or `next()` and before any enquiry about the current state.

The typical use case of done() is in a `for` loop such as:

    for (s->first(); !s->done(); s->next())
      ...

Returns
  false iff the iterator is pointing to a successor.

It is incorrect to call done() if first() hasn't been called before. If done() returns true, it is invalid to call next(), cond(), acc(), or dst().

Implemented in spot::ta_explicit_succ_iterator, spot::twa_graph_succ_iterator< Graph >, spot::kripke_graph_succ_iterator< Graph >, spot::taa_succ_iterator, spot::ta_succ_iterator_product, and spot::tgta_succ_iterator_product.

virtual const state* spot::twa_succ_iterator::dst | ( |  | ) | const
| pure virtual inherited

Get the destination state of the current edge.

Each call to dst() (even several times on the same edge) creates a new state that has to be destroyed (see state::destroy()). by the caller after it is no longer used.

Note that the same state may occur at different points in the iteration, as different outgoing edges (usually with different labels or acceptance membership) may go to the same state.

Implemented in spot::ta_explicit_succ_iterator, spot::twa_graph_succ_iterator< Graph >, spot::kripke_graph_succ_iterator< Graph >, spot::taa_succ_iterator, spot::ta_succ_iterator_product, and spot::tgta_succ_iterator_product.

virtual bool spot::twa_succ_iterator::first | ( |  | ) |
| pure virtual inherited

Position the iterator on the first successor (if any).

This method can be called several times in order to make multiple passes over successors.

Warning
  One should always call `done()` (or better: check the return value of first()) to ensure there is a successor, even after `first()`. A common trap is to assume that there is at least one successor: this is wrong.

Returns
  true iff there is at least one successor

If first() returns false, it is invalid to call next(), cond(), acc(), or dst().

Implemented in spot::ta_explicit_succ_iterator, spot::twa_graph_succ_iterator< Graph >, spot::kripke_graph_succ_iterator< Graph >, spot::taa_succ_iterator, spot::ta_succ_iterator_product, and spot::tgta_succ_iterator_product.

virtual bool spot::twa_succ_iterator::next | ( |  | ) |
| pure virtual inherited

Jump to the next successor (if any).

Warning
  Again, one should always call `done()` (or better: check the return value of next()) ensure there is a successor.

Returns
  true if the iterator moved to a new successor, false if the iterator could not move to a new successor.

If next() returns false, it is invalid to call next() again, or to call cond(), acc() or dst().

Implemented in spot::ta_explicit_succ_iterator, spot::twa_graph_succ_iterator< Graph >, spot::kripke_graph_succ_iterator< Graph >, spot::taa_succ_iterator, spot::ta_succ_iterator_product, and spot::tgta_succ_iterator_product.

The documentation for this class was generated from the following file:

- spot/kripke/fairkripke.hh

Please direct any question, comment, or bug report to the Spot mailing list at spot@lrde.epita.fr.